/**
 * @file Description
 * @author Denis Chenu
 * @copyright Denis Chenu <http://www.sondages.pro>
 * @version 1.0.3
 * @license magnet:?xt=urn:btih:1f739d935676111cfff4b4693e3816e664797050&dn=gpl-3.0.txt GPL-v3-or-Later
 * @license magnet:?xt=urn:btih:0b31508aeb0634b347b8270c7bee4d411b5d4109&dn=agpl-3.0.txt AGPL v3.0
 */

function tableHeaderFix(qid,doCol,doLine,maxHeight){
  var $table=$("#question"+qid+" table.question");
  $table.css("margin-top",0);
  $table.css("table-layout","fixed");
  $table.find("tr.repeat.headings").remove();
  var $baseElement=$table.closest("div");
  var $tableWrapper=$("<div/>");
  $tableWrapper.addClass("thf-table-wrapper");
  $table.wrap($tableWrapper);
  $tableWrapper=$baseElement.find(".thf-table-wrapper");
  if(maxHeight>1){
    $tableWrapper.css("max-height",maxHeight+"em");
  } else {
    /* Set the height to windows height - 40px - optionnal javascript var : tableHeaderFixMinimize */
    tableHeaderFixMinimize=tableHeaderFixMinimize | 0;
    $tableWrapper.css("max-height",($(window).innerHeight()- 40 - tableHeaderFixMinimize)+"px");
  }
  if(doCol){
    $baseElement.addClass("thf-no-overflow");
    fixLine($table,$tableWrapper,$baseElement);
  }
  if(doLine){
    $table.floatThead({
      position: 'absolute',
      scrollContainer: true,
      zIndex:5
    });
    if(doCol){
      addMaskElement($table,$tableWrapper,$baseElement);
    }
  }
}
function addMaskElement($table,$tableWrapper,$baseElement){

    var $maskElement = $("<table/>");
    var $firstCell= $("<td/>");
    var $floatheadContainer=$baseElement.find(".floatThead-container");
    var $tableFloat=$baseElement.find(".floatThead-table");
    $firstCell.css("height",$tableFloat.find("thead td").first().height()+"px");
    $firstCell.css("width",$tableFloat.find("thead td").first().width()+"px");
    $maskElement.attr('class', $table.attr('class'));
    $maskElement.addClass("thf-floatCol");
    $maskElement.css("margin-top",0);
    $maskElement.append("<thead/>");
    $maskElement.children("thead").append("<tr/>");
    $maskElement.children("thead").children("tr").append($firstCell);
    var $maskContainer=$("<div/>");
    $maskContainer.attr('class','thf-maskContainer');
    $maskContainer.attr('style', "overflow: hidden;padding:0;position: absolute;top: 0;left:0;z-index:5;");
    $maskContainer.prepend($maskElement);

    $floatheadContainer.append($maskContainer);
    $tableWrapper.on('scroll', function (e) {
      $maskContainer.css('left',$tableWrapper.scrollLeft()+"px");
    });
}
function fixLine($table,$tableWrapper,$baseElement){
  $table.find("col").each(function(){
      $(this).removeAttr("width");
  });
  $table.find("tbody tr th").each(function(){
    $(this).removeAttr("width");
  });
  /* Construct a new table with only 1st column */
  var $colTable = $("<table/>");
  $colTable.attr('class', $table.attr('class'));
  $colTable.addClass("thf-floatCol");
  $colTable.css("margin-top",0);
  /* Header and 1st td */
  var $firstCell= $("<th/>");
  $firstCell.css("height",$table.find("thead th").first().height()+"px");
  $colTable.append("<thead/>");
  $colTable.children("thead").append("<tr/>");
  $colTable.children("thead").children("tr").append($firstCell);
  $colTable.append("<tbody>");

  $table.find("tbody tr").each(function(){
      var $cell=$(this).find("th:first").clone();
      $cell.find("input").remove();
      //~ $cell.height($(this).find("th:first").height());
      //~ $cell.css("width",$(this).find("th:first").width()+"px");
      var $line=$("<tr/>");
      $line.attr('class', $(this).attr('class'));
      $line.attr('style', $(this).attr('style'));
      //~ $line.height($(this).height());
      $line.append($cell);
      $colTable.children("tbody").append($line);
  });

  var $colFloatContainer=$("<div/>");
  $colFloatContainer.attr('class','thf-floatColContainer');
  $colFloatContainer.attr('style', "overflow: hidden;padding:0;position: absolute;top: 0;z-index:4;left:0;");
  $colFloatContainer.css('left', 'auto');
  $colFloatContainer.width($table.find("th,td").first().outerWidth()+1);
  $colFloatContainer.append($colTable);
  $tableWrapper.append($colFloatContainer);
  $colFloatContainer=$baseElement.find(".thf-floatColContainer");
  $tableWrapper.on('scroll', function (e) {
    $colFloatContainer.css('left',$tableWrapper.scrollLeft()+"px");
    $baseElement.find(".thf-doubleWidth").scrollLeft($tableWrapper.scrollLeft());
  });
  /* Add the double width */
  var $doubleWidth=$("<div/>");
  $doubleWidth.addClass("thf-doubleWidth");
  $doubleWidth.append("<div/>");
  $doubleWidth.children("div").width($table.width());
  $doubleWidth.prependTo($baseElement);
  $doubleWidth.on('scroll', function (e) {
    $colFloatContainer.css('left',$doubleWidth.scrollLeft()+"px");
    $tableWrapper.scrollLeft($doubleWidth.scrollLeft());
  });
}
